﻿Partial Public Class AllNavigationEvents
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()
        AddHandler Loaded, AddressOf AllNavigationEvents_Loaded
        Me.instanceId = nextId
        nextId += 1
    End Sub

    Private Sub AllNavigationEvents_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Debug.WriteLine("Loaded " & instanceId)
        If nextId = 1 Then
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigating, AddressOf AllNavigationEvents_Navigating
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).Navigated, AddressOf AllNavigationEvents_Navigated
            AddHandler (CType(App.Current.RootVisual, PhoneApplicationFrame)).NavigationStopped, AddressOf AllNavigationEvents_NavigationStopped
        End If

        PageTitle.Text = "Instance " & instanceId

        backButton.IsEnabled = NavigationService.CanGoBack
        forwardButton.IsEnabled = NavigationService.CanGoForward
    End Sub

    Private Sub AllNavigationEvents_NavigationStopped(ByVal sender As Object, ByVal e As Windows.Navigation.NavigationEventArgs)
        Debug.WriteLine("Navigation Stopped " & e.Uri.ToString)
    End Sub

    Private Sub AllNavigationEvents_Navigated(ByVal sender As Object, ByVal e As Windows.Navigation.NavigationEventArgs)
        Debug.WriteLine("Navigated to " & e.Uri.ToString)
    End Sub

    Private Sub AllNavigationEvents_Navigating(ByVal sender As Object, ByVal e As Windows.Navigation.NavigatingCancelEventArgs)
        Debug.WriteLine("Navigating to " & e.Uri.ToString)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(ByVal e As Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedFrom(e)
        Debug.WriteLine("OnNavigatedFrom " & instanceId)
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal e As Windows.Navigation.NavigationEventArgs)
        MyBase.OnNavigatedTo(e)
        Debug.WriteLine("OnNavigatedTo " & instanceId)
    End Sub

    Private Sub OnBack(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        If NavigationService.CanGoBack Then NavigationService.GoBack()

    End Sub

    Private Sub OnForward(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        If NavigationService.CanGoForward Then NavigationService.GoForward()

    End Sub

    Private Shared nextId As Integer
    Private instanceId As Integer

    Private Sub OnNavigateNext(ByVal unused As Object, ByVal unused2 As RoutedEventArgs)
        Dim [next] = String.Format("/AllNavigationEvents.xaml?nextId={0}", nextId)
        Dim uri As New Uri([next], UriKind.Relative)
        Me.NavigationService.Navigate(uri)

    End Sub
End Class