﻿Partial Public Class TransientUISample
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()
    End Sub

    Private loginDialogPopup As Popup
    Private loginDialog As LoginUserControl
    Private applicationBarVisibilityPreDialog As Boolean
    Private isShowingTransientUI As Boolean

    Private Sub OnPopup(ByVal unused1 As Object, ByVal unused2 As RoutedEventArgs)
        OnShowTransientUI(True)
    End Sub

    Private Sub OnInlinePopup(ByVal unused1 As Object, ByVal unused2 As RoutedEventArgs)
        OnShowTransientUI(False)
    End Sub

    Private Sub OnShowTransientUI(ByVal usingPopup As Boolean)

        If Me.ApplicationBar IsNot Nothing Then
            applicationBarVisibilityPreDialog = Me.ApplicationBar.IsVisible
            Me.ApplicationBar.IsVisible = False
        End If

        loginDialog = New LoginUserControl
        'we do this width/heights because our page has not Measured/Arranged 
        'since we disabled ApplicationBar..  
        'if you want ApplicationBar to stay visible, simply use ActualWidth/ActualHeight 
        loginDialog.Width = If(Me.ActualWidth > 480, 800, 480)
        loginDialog.Height = If(Me.ActualHeight > 480, 800, 480)

        AddHandler loginDialog.LoginCompleted, AddressOf loginDialog_LoginCompleted


        Dim sb = TryCast(Me.Resources("SlideUpFadeIn"), Storyboard)
        If usingPopup Then
            loginDialogPopup = New Popup
            loginDialogPopup.RenderTransform = New CompositeTransform
            loginDialogPopup.Child = loginDialog
            loginDialogPopup.IsOpen = True
            Storyboard.SetTarget(sb, loginDialogPopup)
            LayoutRoot.Children.Add(loginDialogPopup)
        Else
            loginDialog.RenderTransform = New CompositeTransform
            LayoutRoot.Children.Add(loginDialog)
            Storyboard.SetTarget(sb, loginDialog)
        End If
        isShowingTransientUI = True
        AddHandler sb.Completed, AddressOf sb_Completed
        sb.Begin()

    End Sub

    Private Sub sb_Completed(ByVal sender As Object, ByVal e As EventArgs)
        Dim sb = TryCast(sender, Storyboard)
        sb.Stop()
        Diagnostics.Debug.WriteLine("Completed")

    End Sub

    Private Sub DismissTransientUI()
        If Me.ApplicationBar IsNot Nothing Then Me.ApplicationBar.IsVisible = applicationBarVisibilityPreDialog

        If loginDialogPopup IsNot Nothing Then
            loginDialogPopup.IsOpen = False

            LayoutRoot.Children.Remove(loginDialogPopup)
            loginDialogPopup = Nothing

        Else
            LayoutRoot.Children.Remove(loginDialog)
        End If
        isShowingTransientUI = False
    End Sub
    Private Sub loginDialog_LoginCompleted(ByVal unused1 As Object, ByVal unused2 As EventArgs)
        DismissTransientUI()
    End Sub

    Protected Overrides Sub OnBackKeyPress(ByVal e As ComponentModel.CancelEventArgs)
        MyBase.OnBackKeyPress(e)

        If isShowingTransientUI Then
            e.Cancel = True
            DismissTransientUI()
        End If
    End Sub

End Class